## opencc 0.2.0

=== CMakeLists.txt ===
#
# Open Chinese Convert
#
# Copyright 2010 BYVoid <byvoid.kcp@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

######## Project settings
cmake_minimum_required(VERSION 2.8)
set (PACKAGE_NAME opencc)
project (${PACKAGE_NAME} C)
enable_testing()

######## Package information
set (PACKAGE_URL http://code.google.com/p/open-chinese-convert)
set (PACKAGE_BUGREPORT http://code.google.com/p/open-chinese-convert/issues/entry)
set (OPENCC_VERSION_MAJOR 0)
set (OPENCC_VERSION_MINOR 2)
set (OPENCC_VERSION_REVISION 0)

if (CMAKE_BUILD_TYPE MATCHES Debug)
	set (version_suffix .Debug)
endif (CMAKE_BUILD_TYPE MATCHES Debug)

set (
	OPENCC_VERSION
	${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}${version_suffix}
)

######## Validation

if (ENABLE_GETTEXT)
	find_package(Gettext REQUIRED)
endif (ENABLE_GETTEXT)

include (TestBigEndian)
TEST_BIG_ENDIAN(BIGENDIAN)
if (BIGENDIAN)
	set (BYTEORDER BIG_ENDIAN)
else (BIGENDIAN)
	set (BYTEORDER LITTLE_ENDIAN)
endif (BIGENDIAN)

######## Directory

set (DIR_PREFIX ${CMAKE_INSTALL_PREFIX})
set (DIR_LIBRARY ${CMAKE_SHARED_LIBRARY_PREFIX})
set (DIR_LIBRARY_STATIC ${CMAKE_STATIC_LIBRARY_PREFIX})
set (DIR_INCLUDE include)
set (DIR_SHARE share)
set (DIR_BIN bin)
set (PKGDATADIR ${DIR_PREFIX}/${DIR_SHARE}/opencc)
set (LOCALEDIR ${DIR_PREFIX}/${DIR_SHARE}/locale)

######## Configuration

configure_file(
	opencc.pc.in
	opencc.pc
	@ONLY
)

install(
	FILES
		${CMAKE_BINARY_DIR}/opencc.pc
	DESTINATION
		${DIR_LIBRARY}/pkgconfig
)

######## Subdirectories

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(data)

if (GETTEXT_FOUND AND ENABLE_GETTEXT)
	add_subdirectory(po)
endif (GETTEXT_FOUND AND ENABLE_GETTEXT)

add_subdirectory(test)

=== data/CMakeLists.txt ===
set(
	OPENCC_DICT_BIN
	${CMAKE_BINARY_DIR}/src/tools/opencc_dict
)

add_custom_target(
	ocds
	ALL
	DEPENDS
		simp_to_trad_characters.ocd
		simp_to_trad_phrases.ocd
		trad_to_simp_characters.ocd
		trad_to_simp_phrases.ocd
)

foreach(DICT_PREFIX simp_to_trad trad_to_simp)

	foreach(DICT_SURFIX characters phrases)

		set (DICT ${DICT_PREFIX}_${DICT_SURFIX})

		add_custom_command(
			OUTPUT
				${DICT}.ocd
			COMMENT
				"Building ${DICT}.ocd"
			COMMAND
				${OPENCC_DICT_BIN} -i ${CMAKE_SOURCE_DIR}/data/${DICT_PREFIX}/${DICT_SURFIX}.txt -o ${DICT}.ocd
			DEPENDS opencc_dict
		)

		install(
			FILES
				${CMAKE_BINARY_DIR}/data/${DICT}.ocd
			DESTINATION
				${DIR_SHARE}/opencc
		)

		set_directory_properties(
			PROPERTIES
				ADDITIONAL_MAKE_CLEAN_FILES
					"${CMAKE_BINARY_DIR}/data/${DICT}.ocd"
		)

	endforeach(DICT_SURFIX)
endforeach(DICT_PREFIX)

set(CONFIG_FILES
	config/zhs2zht.ini
	config/zht2zhs.ini
	config/mix2zht.ini
	config/mix2zhs.ini
)

install(
	FILES
		${CONFIG_FILES}
	DESTINATION
		${DIR_SHARE}/opencc
)

=== po/CMakeLists.txt ===
file(STRINGS LINGUAS LANGUAGES)
separate_arguments(LANGUAGES)
set(DOMAIN ${PACKAGE_NAME})
set(LOCALE_INSTALL ${DIR_SHARE}/locale)
set(LOCALEDIR po)

############ Validation. ###########

find_program(GETTEXT_MSGINIT_EXECUTABLE msginit)
if(NOT GETTEXT_MSGINIT_EXECUTABLE)
	message(FATAL_ERROR "msginit not found")
endif(NOT GETTEXT_MSGINIT_EXECUTABLE)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if(NOT GETTEXT_XGETTEXT_EXECUTABLE )
	message(FATAL_ERROR "xgettext not found")
endif(NOT GETTEXT_XGETTEXT_EXECUTABLE )

find_program(GETTEXT_MSGCAT_EXECUTABLE msgcat)
if(NOT GETTEXT_MSGCAT_EXECUTABLE )
	message(FATAL_ERROR "msgcat not found")
endif(NOT GETTEXT_MSGCAT_EXECUTABLE )

find_program(GETTEXT_MSGATTRIB_EXECUTABLE msgattrib)
if(NOT GETTEXT_MSGATTRIB_EXECUTABLE)
	message(FATAL_ERROR "msgattrib not found")
endif(NOT GETTEXT_MSGATTRIB_EXECUTABLE)

foreach(LANG ${LANGUAGES})

	add_custom_target(
		${LANG}_mo
		ALL
		DEPENDS
			${LANG}.mo
	)

	add_custom_command(
		OUTPUT ${LANG}.mo
		COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
				${GETTEXT_MSGFMT_PARAMETER}
				-o ${LANG}.mo ${CMAKE_SOURCE_DIR}/po/${LANG}.po
		DEPENDS 
			${LANG}.po
		COMMENT "mo-update [${LANG}]: Creating mo file."
	)

	install(
		FILES
			${CMAKE_BINARY_DIR}/po/${LANG}.mo
		RENAME
			${DOMAIN}.mo
		DESTINATION
			${LOCALE_INSTALL}/${LANG}/LC_MESSAGES
	)

endforeach(LANG ${LANGUAGES})

=== src/CMakeLists.txt ===
set(
	LIBOPENCC_HEADERS
	opencc.h
	opencc_types.h
	wrapper/cplusplus/openccxx.h
)

set(
	LIBOPENCC_DICTIONARY_SOURCES
	dictionary/abstract.c
	dictionary/datrie.c
	dictionary/text.c
	dictionary/abstract.h
	dictionary/datrie.h
	dictionary/text.h
)

set(
	LIBOPENCC_SOURCES
	${LIBOPENCC_DICTIONARY_SOURCES}
	config_reader.c
	converter.c
	dictionary_group.c
	dictionary_set.c
	encoding.c
	utils.c
	opencc.c
	config_reader.h
	converter.h
	dictionary_group.h
	dictionary_set.h
	encoding.h
	utils.h
)

set (LIBOPENCC_TARGET libopencc)
set (LIBOPENCC_STATIC_TARGET libopencc_static)

add_definitions(
	-DPKGDATADIR="${PKGDATADIR}"
	-DLOCALEDIR="${LOCALEDIR}"
	-DVERSION="${OPENCC_VERSION}"
	-DBYTEORDER=${BYTEORDER}
	-DPACKAGE_NAME="${PACKAGE_NAME}"
	-Wall
)

add_library(
	${LIBOPENCC_TARGET}
	SHARED
	${LIBOPENCC_SOURCES}
)

add_library(
	${LIBOPENCC_STATIC_TARGET}
	STATIC
	${LIBOPENCC_SOURCES}
)

set_target_properties(
	${LIBOPENCC_TARGET}
	${LIBOPENCC_STATIC_TARGET}
	PROPERTIES
		OUTPUT_NAME
			opencc
		VERSION
			1.0.0
		SOVERSION
			1
)

if (ENABLE_GETTEXT)

	add_definitions(
		-DENABLE_GETTEXT
	)
	
	link_directories(
	${GETTEXT_LIBRARIES}
	)

	include_directories(
		${GETTEXT_INCLUDE_DIR}
	)
	
endif (ENABLE_GETTEXT)

if (CMAKE_BUILD_TYPE MATCHES Debug)

	add_definitions(
		-O0
		-g3
	)

endif (CMAKE_BUILD_TYPE MATCHES Debug)

install(
	TARGETS
		${LIBOPENCC_TARGET}
	LIBRARY DESTINATION
		${DIR_LIBRARY}
)

install(
	TARGETS
		${LIBOPENCC_STATIC_TARGET}
	ARCHIVE DESTINATION
		${DIR_LIBRARY_STATIC}
)

install(
	FILES
		${LIBOPENCC_HEADERS}
	DESTINATION
		${DIR_INCLUDE}/opencc
)

include(symbols.cmake)

add_subdirectory(tools)

=== test/CMakeLists.txt ===
set(CONFIGURATIONS zhs2zht zht2zhs mix2zht mix2zhs)

foreach(CONFIG ${CONFIGURATIONS})

	add_test(
		${CONFIG}_convert
		${CMAKE_COMMAND} -E chdir ${PROJECT_BINARY_DIR}/data
		${PROJECT_BINARY_DIR}/src/tools/opencc
		-i ${CMAKE_SOURCE_DIR}/test/testcases/${CONFIG}.in
		-o ${PROJECT_BINARY_DIR}/test/${CONFIG}.out
		-c ${CMAKE_SOURCE_DIR}/data/config/${CONFIG}.ini
	)
	
	add_test(
		${CONFIG}_compare
		diff
		${PROJECT_BINARY_DIR}/test/${CONFIG}.out
		${CMAKE_SOURCE_DIR}/test/testcases/${CONFIG}.ans
	)
	
	set_property(
		TEST ${CONFIG}_compare
		APPEND PROPERTY
			DEPENDS ${CONFIG}_convert)

endforeach(CONFIG)

## opencc 0.0.3

=== debian/changelog ===
opencc (0.0.3-1) unstable; urgency=low

  * New upstream release.
  * debian/opencc.install: updated.
  * debian/control: opencc depends on libopencc0 at the same version. 

 -- LI Daobing <lidaobing@debian.org>  Tue, 22 Jun 2010 19:08:33 +0800

opencc (0.0.2-1) unstable; urgency=low

  * Initial release (Closes: #585621)

 -- LI Daobing <lidaobing@debian.org>  Sat, 19 Jun 2010 18:27:20 +0800

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org> 
Uploaders: LI Daobing <lidaobing@debian.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, python
Standards-Version: 3.8.4
Section: libs
Homepage: http://code.google.com/p/open-chinese-convert
Vcs-Bzr: lp:~pkg-ime/opencc/debian-opencc
Vcs-Browser: https://code.launchpad.net/~pkg-ime/opencc/debian-opencc

Package: libopencc-dev
Section: libdevel
Architecture: any
Depends: libopencc0 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional chinese conversion library - development
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the development support files.

Package: libopencc0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: simplified-traditional chinese conversion library - runtime
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the shared library.

Package: opencc
Section: utils
Architecture: any
Depends: libopencc0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: simplified-traditional chinese conversion tool
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the conversion tool.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh  $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-static

=== debian/watch ===
version=3
opts=downloadurlmangle=s#.*(opencc-([\d.]+)\.tar\.gz).*#http://open-chinese-convert.googlecode.com/files/$1#,\
filenamemangle=s#.*(opencc-([\d.]+)\.tar\.gz).*#$1# \
	http://code.google.com/p/open-chinese-convert/downloads/list ^.*detail\?name=opencc-([\d.]+)\.tar\.gz.*

## opencc 0.1.1

=== debian/changelog ===
opencc (0.1.1-1) unstable; urgency=low

  [ Asias He ]
  * New upstream release (closes: #591076).
  * debian/control: bump standards version to 3.9.1.
  * debian/watch: use googlecode.debian.net.

  [ LI Daobing ]
  * debian/clean: added. 

 -- LI Daobing <lidaobing@debian.org>  Wed, 11 Aug 2010 22:04:12 +0800

opencc (0.1.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - bump standards version to 3.9.1.
    - libopencc0 -> libopecc1 (closes: #590473).
    - libopencc1 replaces libopencc0.
  * libopencc0 -> libopencc1:
    - debian/libopencc0.install => debian/libopencc1.install
    - debian/libopencc0.symbols => debian/libopencc1.symbols

 -- LI Daobing <lidaobing@debian.org>  Thu, 29 Jul 2010 23:05:17 +0800

opencc (0.0.5-1) unstable; urgency=low

  * New upstream release.
  * debain/control: no longer build depends on python. 
  * debian/opencc.install: move .mo files to libopencc0.
  * debian/libopencc0.install: install .mo files.
  * debian/opencc_dict.1: deleted.
  * debian/opencc.manpages: deleted.

 -- LI Daobing <lidaobing@debian.org>  Wed, 21 Jul 2010 22:42:32 +0800

opencc (0.0.4-1) unstable; urgency=low

  * New upstream release.
  * debian/control: bump standards version to 3.9.0.

 -- LI Daobing <lidaobing@debian.org>  Fri, 16 Jul 2010 23:52:08 +0800

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org> 
Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias.hejun@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev
Standards-Version: 3.9.1
Section: libs
Homepage: http://code.google.com/p/open-chinese-convert
Vcs-Bzr: lp:~pkg-ime/opencc/debian-opencc
Vcs-Browser: https://code.launchpad.net/~pkg-ime/opencc/debian-opencc

Package: libopencc-dev
Section: libdevel
Architecture: any
Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional chinese conversion library - development
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the development support files.

Package: libopencc1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopencc0
Description: simplified-traditional chinese conversion library - runtime
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the shared library.

Package: opencc
Section: utils
Architecture: any
Depends: libopencc1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: simplified-traditional chinese conversion tool
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the conversion tool.

## opencc 0.1.2

=== debian/changelog ===
opencc (0.1.2-1) unstable; urgency=low

  * New upstream release.
  * debian/libopencc1.symbols: updated. 

 -- LI Daobing <lidaobing@debian.org>  Wed, 22 Sep 2010 20:40:54 +0800

opencc (0.1.1-2) unstable; urgency=low

  *debian/control: add Conflicts to libopencc0 (Closes: #596434)

 -- Asias He <asias.hejun@gmail.com>  Sun, 12 Sep 2010 14:58:18 +0800

=== debian/control ===
--- 
+++ 
@@ -24,6 +24,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libopencc0
+Conflicts: libopencc0
 Description: simplified-traditional chinese conversion library - runtime
  opencc is a library for converting character between traditional chinese and
  simplified chinese.

## opencc 0.2.0

=== debian/changelog ===
opencc (0.2.0-2) unstable; urgency=low

  * Fix "Please fix FTBFS on mips, ppc, s390 and sparc" (Closes: #624562)
  * debian/control: bump standards version to 3.9.2.
  * Set DM-Upload-Allowed to yes

 -- Asias He <asias.hejun@gmail.com>  Mon, 16 May 2011 20:46:03 +0800

opencc (0.2.0-1) unstable; urgency=low

  * New upstream release
  * Move usr/share/locale to package opencc
  * Add cmake to Build-Depends
  * Change Homepage to http://code.google.com/p/opencc
  * Set Vcs to git.debian.org

 -- Asias He <asias.hejun@gmail.com>  Thu, 17 Mar 2011 21:36:41 +0800

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org> 
Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias.hejun@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, cmake, quilt (>= 0.46-7~)
Standards-Version: 3.9.2
Section: libs
Homepage: http://code.google.com/p/opencc
Vcs-Git: git://git.debian.org/git/pkg-ime/opencc.git
Vcs-Browser: http://git.debian.org/?p=pkg-ime/opencc.git
DM-Upload-Allowed: yes

Package: opencc
Section: utils
Architecture: any
Depends: libopencc1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: simplified-traditional chinese conversion tool
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the conversion tool.

Package: libopencc1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopencc0
Conflicts: libopencc0
Description: simplified-traditional chinese conversion library - runtime
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the shared library.

Package: libopencc-dev
Section: libdevel
Architecture: any
Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional chinese conversion library - development
 opencc is a library for converting character between traditional chinese and
 simplified chinese. 
 .
 This package includes the development support files.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh  $@ --with quilt

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release -DENABLE_GETTEXT:BOOL=ON

=== debian/watch ===
version=3
http://googlecode.debian.net/p/open-chinese-convert/opencc-(\d+.*)\.tar\.gz

## opencc 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,10 +23,10 @@
 enable_testing()
 
 ######## Package information
-set (PACKAGE_URL http://code.google.com/p/open-chinese-convert)
-set (PACKAGE_BUGREPORT http://code.google.com/p/open-chinese-convert/issues/entry)
+set (PACKAGE_URL http://code.google.com/p/opencc)
+set (PACKAGE_BUGREPORT http://code.google.com/p/opencc/issues/entry)
 set (OPENCC_VERSION_MAJOR 0)
-set (OPENCC_VERSION_MINOR 2)
+set (OPENCC_VERSION_MINOR 3)
 set (OPENCC_VERSION_REVISION 0)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
@@ -52,16 +52,42 @@
 	set (BYTEORDER LITTLE_ENDIAN)
 endif (BIGENDIAN)
 
+######## Windows
+
+if (WIN32)
+	set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
+	set(CMAKE_STATIC_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
+endif (WIN32)
+
 ######## Directory
 
 set (DIR_PREFIX ${CMAKE_INSTALL_PREFIX})
-set (DIR_LIBRARY ${CMAKE_SHARED_LIBRARY_PREFIX})
-set (DIR_LIBRARY_STATIC ${CMAKE_STATIC_LIBRARY_PREFIX})
-set (DIR_INCLUDE include)
-set (DIR_SHARE share)
-set (DIR_BIN bin)
-set (PKGDATADIR ${DIR_PREFIX}/${DIR_SHARE}/opencc)
-set (LOCALEDIR ${DIR_PREFIX}/${DIR_SHARE}/locale)
+set (DIR_LIBRARY ${DIR_PREFIX}/${CMAKE_SHARED_LIBRARY_PREFIX})
+set (DIR_LIBRARY_STATIC ${DIR_PREFIX}/${CMAKE_STATIC_LIBRARY_PREFIX})
+set (DIR_INCLUDE ${DIR_PREFIX}/include)
+set (DIR_SHARE ${DIR_PREFIX}/share)
+set (DIR_BIN ${DIR_PREFIX}/bin)
+set (DIR_ETC ${DIR_PREFIX}/etc)
+
+if (DEFINED CMAKE_INSTALL_LIBDIR)
+	set (DIR_LIBRARY ${CMAKE_INSTALL_LIBDIR})
+	set (DIR_LIBRARY_STATIC ${CMAKE_INSTALL_LIBDIR})
+endif (DEFINED CMAKE_INSTALL_LIBDIR)
+
+if (DEFINED SHARE_INSTALL_PREFIX)
+	set (DIR_SHARE ${SHARE_INSTALL_PREFIX})
+endif (DEFINED SHARE_INSTALL_PREFIX)
+
+if (DEFINED INCLUDE_INSTALL_DIR)
+	set (DIR_INCLUDE ${INCLUDE_INSTALL_DIR})
+endif (DEFINED INCLUDE_INSTALL_DIR)
+
+if (DEFINED SYSCONF_INSTALL_DIR)
+	set (DIR_ETC ${SYSCONF_INSTALL_DIR})
+endif (DEFINED SYSCONF_INSTALL_DIR)
+
+set (DIR_SHARE_OPENCC ${DIR_SHARE}/opencc)
+set (DIR_SHARE_LOCALE ${DIR_SHARE}/locale)
 
 ######## Configuration

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 			FILES
 				${CMAKE_BINARY_DIR}/data/${DICT}.ocd
 			DESTINATION
-				${DIR_SHARE}/opencc
+				${DIR_SHARE_OPENCC}
 		)
 
 		set_directory_properties(
@@ -50,11 +50,46 @@
 	config/zht2zhs.ini
 	config/mix2zht.ini
 	config/mix2zhs.ini
+	config/zhs2zhtw_p.ini
+	config/zhs2zhtw_v.ini
+	config/zhs2zhtw_vp.ini
+	config/zht2zhtw_p.ini
+	config/zht2zhtw_v.ini
+	config/zht2zhtw_vp.ini
+	config/zhtw2zht.ini
+	config/zhtw2zhs.ini
+	config/zhtw2zhcn_s.ini
+	config/zhtw2zhcn_t.ini
 )
 
 install(
 	FILES
 		${CONFIG_FILES}
 	DESTINATION
-		${DIR_SHARE}/opencc
+		${DIR_SHARE_OPENCC}
 )
+
+set(TAIWAN_DICT_FILES
+	tw/to_tw_variants.txt
+	tw/to_tw_phrases.txt
+	tw/from_tw_variants.txt
+	tw/from_tw_phrases.txt
+)
+
+install(
+	FILES
+		${TAIWAN_DICT_FILES}
+	DESTINATION
+		${DIR_SHARE_OPENCC}
+)
+
+set(CHINA_DICT_FILES
+	cn/to_cn_phrases.txt
+)
+
+install(
+	FILES
+		${CHINA_DICT_FILES}
+	DESTINATION
+		${DIR_SHARE_OPENCC}
+)

=== doc/CMakeLists.txt ===
install(
	FILES
		opencc.1
		opencc_dict.1
	DESTINATION
		${DIR_SHARE}/man/man1
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -37,8 +37,8 @@
 set (LIBOPENCC_STATIC_TARGET libopencc_static)
 
 add_definitions(
-	-DPKGDATADIR="${PKGDATADIR}"
-	-DLOCALEDIR="${LOCALEDIR}"
+	-DPKGDATADIR="${DIR_SHARE_OPENCC}"
+	-DLOCALEDIR="${DIR_SHARE_LOCALE}"
 	-DVERSION="${OPENCC_VERSION}"
 	-DBYTEORDER=${BYTEORDER}
 	-DPACKAGE_NAME="${PACKAGE_NAME}"
@@ -94,12 +94,14 @@
 
 endif (CMAKE_BUILD_TYPE MATCHES Debug)
 
+if (NOT WIN32)
 install(
 	TARGETS
 		${LIBOPENCC_TARGET}
 	LIBRARY DESTINATION
 		${DIR_LIBRARY}
 )
+endif (NOT WIN32)
 
 install(
 	TARGETS

=== src/tools/CMakeLists.txt ===
set(
	LIBOPENCC_DICTIONARY_SOURCES
	../dictionary/abstract.c
	../dictionary/datrie.c
	../dictionary/text.c
	../dictionary/abstract.h
	../dictionary/datrie.h
	../dictionary/text.h
)

set(
	OPENCC_DCIT_SOURCES
	${LIBOPENCC_DICTIONARY_SOURCES}
	opencc_dict.c
	../dictionary_group.c
	../dictionary_group.h
	../encoding.c
	../encoding.h
	../utils.c
	../utils.h
)

add_executable(
	opencc_dict
	${OPENCC_DCIT_SOURCES}
)

target_link_libraries(
	opencc_dict
	${LIBOPENCC_TARGET}
)

install(
	TARGETS
		opencc_dict
	RUNTIME
	DESTINATION
		${DIR_BIN}
)


set(
	OPENCC_SOURCES
	opencc.c
	../utils.c
	../utils.h
)

add_executable(
	opencc
	${OPENCC_SOURCES}
)

add_dependencies(
	opencc
	ocds
)

target_link_libraries(
	opencc
	${LIBOPENCC_TARGET}
)

install(
	TARGETS
		opencc
	RUNTIME
	DESTINATION
		${DIR_BIN}
)

=== debian/changelog ===
opencc (0.3.0-3~bpo60+1) squeeze-backports; urgency=low

  * Backports to squeeze.
    - Undo multi-arch support.

 -- Kan-Ru Chen <koster@debian.org>  Wed, 13 Jun 2012 07:38:56 +0800

opencc (0.3.0-3) unstable; urgency=low

  * Rebuild to 
    generate little endian mo file on any arch (Closes: #670016).
  * add an - before include buildflags.mk

 -- YunQiang Su <wzssyqa@gmail.com>  Sun, 10 Jun 2012 19:35:51 +0800

opencc (0.3.0-2) unstable; urgency=low

  * Multi-arch it.
  * Add libopencc-dbg package.
  * Bump standard version to 3.9.3.
  * Add YunQiang Su to Uploaders.
  * Enable CPPFLAGS hardening flags (Closes: #665322).
  * Better explanation for the -c option arguments of opencc,
    give the path of these files out. (Closes: #656201).

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 29 Mar 2012 03:22:51 +0800

opencc (0.3.0-1) unstable; urgency=low

  * Team upload.

  [ Kan-Ru Chen ]
  * New upstream release
  * debian/control:
    - Remove autotools-dev and quilt from Build-Depends
  * debian/rules:
    - Support `nostrip' DEB_BUILD_OPTIONS
    - Enable hardening flags.
  * debian/docs: Install NEWS
  * debian/copyright: Update update url
  * debian/watch: Update upstream url
  * debian/patches/fix-big-endian-build.diff: merged upstream
  * debian/patches/fix-new-test-cases.patch: New patch.

 -- Kan-Ru Chen <koster@debian.org>  Sat, 17 Dec 2011 16:41:49 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: opencc
 Priority: optional
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org> 
-Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias.hejun@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, cmake, quilt (>= 0.46-7~)
-Standards-Version: 3.9.2
+Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias.hejun@gmail.com>,
+		YunQiang Su <wzssyqa@gmail.com>
+Build-Depends: debhelper (>= 8), cmake
+Standards-Version: 3.9.3
 Section: libs
 Homepage: http://code.google.com/p/opencc
 Vcs-Git: git://git.debian.org/git/pkg-ime/opencc.git
@@ -21,8 +22,9 @@
  This package includes the conversion tool.
 
 Package: libopencc1
-Section: libs
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libopencc0
 Conflicts: libopencc0
@@ -41,3 +43,14 @@
  simplified chinese. 
  .
  This package includes the development support files.
+
+Package: libopencc-dbg
+Section: debug
+Priority: extra
+Architecture: any
+Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}
+Description: simplified-traditional chinese conversion library - debug
+ opencc is a library for converting character between traditional chinese and
+ simplified chinese.
+ .
+ This package includes the debug symbols which is useful when debug.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)

%:
	dh  $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib \
		-DCMAKE_BUILD_TYPE=Release \
		-DENABLE_GETTEXT:BOOL=ON

override_dh_strip:
	dh_strip -plibopencc1 --dbg-package=libopencc-dbg
	dh_strip

=== debian/watch ===
version=3
http://googlecode.debian.net/p/opencc/opencc-(\d+.*)\.tar\.gz

## opencc 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,13 +20,14 @@
 cmake_minimum_required(VERSION 2.8)
 set (PACKAGE_NAME opencc)
 project (${PACKAGE_NAME} C)
+include (CTest)
 enable_testing()
 
 ######## Package information
 set (PACKAGE_URL http://code.google.com/p/opencc)
 set (PACKAGE_BUGREPORT http://code.google.com/p/opencc/issues/entry)
 set (OPENCC_VERSION_MAJOR 0)
-set (OPENCC_VERSION_MINOR 3)
+set (OPENCC_VERSION_MINOR 4)
 set (OPENCC_VERSION_REVISION 0)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
@@ -37,6 +38,14 @@
 	OPENCC_VERSION
 	${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}${version_suffix}
 )
+
+set(CPACK_SOURCE_PACKAGE_FILE_NAME
+  "${PACKAGE_NAME}-${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}"
+)
+set(CPACK_SOURCE_IGNORE_FILES
+  "/build/;/release/;/debug/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}"
+)
+include(CPack)
 
 ######## Validation

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,10 @@
 	opencc_dict.c
 	../dictionary_group.c
 	../dictionary_group.h
+	../dictionary_set.c
+	../dictionary_set.h
+	../config_reader.c
+	../config_reader.h
 	../encoding.c
 	../encoding.h
 	../utils.c

=== debian/changelog ===
opencc (0.4.0-1) experimental; urgency=low

  * New upstream release
  * fix-new-test-cases.patch in upstream
  * part of more_clear_man_c_option.patch is in upstream
    the rest is in install-data-file-to-meet-need-of-multi-arch.path

 -- Asias He <asias@debian.org>  Fri, 05 Apr 2013 10:52:29 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: opencc
 Priority: optional
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org> 
-Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias.hejun@gmail.com>,
+Uploaders: LI Daobing <lidaobing@debian.org>, Asias He <asias@debian.org>,
 		YunQiang Su <wzssyqa@gmail.com>
-Build-Depends: debhelper (>= 8), cmake
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1.1~), cmake
 Standards-Version: 3.9.3
 Section: libs
 Homepage: http://code.google.com/p/opencc

## opencc 0.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Open Chinese Convert
 #
-# Copyright 2010 BYVoid <byvoid.kcp@gmail.com>
+# Copyright 2010-2013 BYVoid <byvoid@byvoid.com>
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -28,7 +28,7 @@
 set (PACKAGE_BUGREPORT http://code.google.com/p/opencc/issues/entry)
 set (OPENCC_VERSION_MAJOR 0)
 set (OPENCC_VERSION_MINOR 4)
-set (OPENCC_VERSION_REVISION 0)
+set (OPENCC_VERSION_REVISION 3)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
 	set (version_suffix .Debug)
@@ -43,11 +43,12 @@
   "${PACKAGE_NAME}-${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}"
 )
 set(CPACK_SOURCE_IGNORE_FILES
-  "/build/;/release/;/debug/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}"
+  "/build/;/release/;/debug/;/other/;/opencc.xcodeproj/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}"
 )
 include(CPack)
 
 ######## Validation
+option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
 
 if (ENABLE_GETTEXT)
 	find_package(Gettext REQUIRED)

=== doc/CMakeLists.txt ===
install(
	FILES
		opencc.1
		opencc_dict.1
	DESTINATION
		${DIR_SHARE}/man/man1
)

if(BUILD_DOCUMENTATION)
    find_package(Doxygen)
    if (NOT DOXYGEN_FOUND)
        message(
            FATAL_ERROR 
            "Doxygen is needed to build the documentation. Please install it correctly"
        )
    endif()

    configure_file(
    	opencc.doxy.in
    	opencc.doxy
    	@ONLY
        IMMEDIATE
    )

    add_custom_target(
    	apidoc
    	ALL
    	COMMENT
    		"Building API Documentation"
    	COMMAND
    		doxygen ${PROJECT_BINARY_DIR}/doc/opencc.doxy
        SOURCES
            ${PROJECT_BINARY_DIR}/doc/opencc.doxy
    )

    install(
    	DIRECTORY
    		${CMAKE_BINARY_DIR}/doc/html
    	DESTINATION
    		${DIR_SHARE_OPENCC}/doc
    )

    set_directory_properties(
    	PROPERTIES
    		ADDITIONAL_MAKE_CLEAN_FILES
    			"${CMAKE_BINARY_DIR}/doc/html"
    )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,10 @@
 
 set(
 	LIBOPENCC_DICTIONARY_SOURCES
-	dictionary/abstract.c
+	dict.c
 	dictionary/datrie.c
 	dictionary/text.c
-	dictionary/abstract.h
+	dict.h
 	dictionary/datrie.h
 	dictionary/text.h
 )
@@ -20,15 +20,15 @@
 	${LIBOPENCC_DICTIONARY_SOURCES}
 	config_reader.c
 	converter.c
-	dictionary_group.c
-	dictionary_set.c
+	dict_group.c
+	dict_chain.c
 	encoding.c
 	utils.c
 	opencc.c
 	config_reader.h
 	converter.h
-	dictionary_group.h
-	dictionary_set.h
+	dict_group.h
+	dict_chain.h
 	encoding.h
 	utils.h
 )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,13 @@
-set(CONFIGURATIONS zhs2zht zht2zhs mix2zht mix2zhs)
+set(CONFIGURATIONS
+	zhs2zht
+	zht2zhs
+	mix2zht
+	mix2zhs
+	zhs2zhtw_p
+	zhs2zhtw_vp
+	zhtw2zhcn_t
+	zhtw2zhcn_s
+)
 
 foreach(CONFIG ${CONFIGURATIONS})

=== debian/changelog ===
opencc (0.4.3-2build1) trusty; urgency=medium

  * Rebuild to drop files installed into /usr/share/pyshared.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Feb 2014 13:49:20 +0000

opencc (0.4.3-2) unstable; urgency=low

  * Add the python-opencc package to support the Python binding. 
    Closes: #694993
  * Bump standard version to 3.9.5.

 -- Osamu Aoki <osamu@debian.org>  Sat, 02 Nov 2013 12:17:51 +0900

opencc (0.4.3-1) experimental; urgency=low

  * New upstream release.
  * Update watch file.
  * Clean up debian/control and wrap-and-sort.
  * Update symbols file.

 -- Osamu Aoki <osamu@debian.org>  Sun, 15 Sep 2013 00:13:31 +0900

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: LI Daobing <lidaobing@debian.org>,
           Asias He <asias@debian.org>,
           YunQiang Su <wzssyqa@gmail.com>,
           Osamu Aoki <osamu@debian.org>
Build-Depends: cmake, debhelper (>= 9), python-all
Standards-Version: 3.9.5
Section: libs
Homepage: http://code.google.com/p/opencc
Vcs-Git: git://anonscm.debian.org/pkg-ime/opencc.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/opencc.git

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: simplified-traditional chinese conversion tool
 opencc is a library for converting character between traditional chinese and
 simplified chinese.
 .
 This package includes the conversion tool.

Package: libopencc1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libopencc0
Conflicts: libopencc0
Description: simplified-traditional chinese conversion library - runtime
 opencc is a library for converting character between traditional chinese and
 simplified chinese.
 .
 This package includes the shared library.

Package: libopencc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional chinese conversion library - development
 opencc is a library for converting character between traditional chinese and
 simplified chinese.
 .
 This package includes the development support files.

Package: python-opencc
Section: python
Architecture: all
Depends: libopencc1, ${misc:Depends}, ${python:Depends}
Description: simplified-traditional chinese conversion library - Python support
 opencc is a library for converting character between traditional chinese and
 simplified chinese.
 .
 This package includes the Python binding.

Package: libopencc-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: libopencc1 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional chinese conversion library - debug
 opencc is a library for converting character between traditional chinese and
 simplified chinese.
 .
 This package includes the debug symbols which is useful when debug.

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,15 @@
 # missing (hardening) flags.
 CFLAGS += $(CPPFLAGS)
 
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
 %:
-	dh  $@
+	dh $@ --with python2
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX=/usr \
-		-DCMAKE_INSTALL_LIBDIR=/usr/lib \
+		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
 		-DCMAKE_BUILD_TYPE=Release \
 		-DENABLE_GETTEXT:BOOL=ON

=== debian/watch ===
version=3
opts=downloadurlmangle=s%.*name=(.*?)&.*%https://opencc\.googlecode\.com/files/$1%,filenamemangle=s/.*name=(.*?)&.*/$1/ \
http://code.google.com/p/opencc/downloads/list?can=1&q= \
.*name=opencc(?:-|\.|_|_v|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)&\S*
